#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <errno.h>
#include <process.h>
#include "../common/config.h"
#include "bf_crypt.h"
#include "utils.h"

/* Generic Settings */

#define MAX_STREAM_CHUNK                        8       /* Must be mod 8 */
#define TIMEOUT                                 30
#define HANDSHAKE_SIZE                          32

/* Errors */

#define ERROR_UNKNOWN                           -800
#define ERROR_INIT_KEY                          -801
#define ERROR_HANDSHAKE                         -802
#define ERROR_READLINE                          -803
#define ERROR_ENCRYPTION                        -804

int bf_init(char *key, BFkey_type *ks);  /* intitialised keystring for blowfish */

int bf_client_handshake(int socket, BFkey_type *ks);
int bf_server_handshake(int socket, BFkey_type *ks);

int bf_client_disconnect(int socket, BFkey_type *ks);
void bf_noop(int socket, BFkey_type *ks);

int bf_sendall(int socket, BFkey_type *ks, char *buf, int bytes);
int bf_recvall(int socket, BFkey_type *ks, char *vptr, int maxlen);
int Read(int socket, BFkey_type *ks, char *buf);
int recv_waitall(SOCKET fd, char *buf, int size);

int handshake(int socket, BFkey_type *ks);
void make_random_line(char *line, int len);
